<?php
if (!defined('GAME')) {
    die();
}

session_start();

function jsHelp($txt, $color = 'Black'): void
{
    global $r, $u;
    $r['js'] .= 'chat.sendMsg(["new", "' . time() . '", "6", "", "' . $u->info['login'] . '", "<small>' . $txt . '</small>", "' . $color . '", "1", "1", "0"]);';
}

if (!isset($_SESSION['help_step']) || $_SESSION['help_step'] < 1) {
    $_SESSION['help_step'] = 1;
}


$go_help = [
    1 => [
        1 => 2,
        2 => 3,
        3 => 4,
    ],
    2 => [0 => 1],
    3 => [0 => 1, 1 => 3],
    4 => [0 => 1],
];

if (str_starts_with($_POST['msg'], '/[')) {
    $_POST['msg'] = str_replace(['/[', ']'], '', $_POST['msg']);
    $_POST['msg'] = round((int)$_POST['msg']);
    if (isset($go_help[$_SESSION['help_step']][$_POST['msg']])) {
        $_SESSION['help_step'] = $go_help[$_SESSION['help_step']][$_POST['msg']];
    } else {
        jsHelp('----------------------------------------------------------------------------------------');
        jsHelp('<b style="color: red">Ошибка, раздел справки не найден</b>');
    }
}

if (str_starts_with($_POST['msg'], '/help') || $_SESSION['help_step'] == 1) {
    jsHelp('<b>Добро пожаловать в раздел справки!</b>');
    jsHelp('Вырерите раздел справки: <i>(Отправить ответ в чат. Пример: &quot;/[1]&quot;)</i>');
    jsHelp('[1] Информация о пользовании чатом');
    jsHelp('[2] Нагрузка сервера');
    jsHelp('[3] Закрыть справку');
} elseif ($_SESSION['help_step'] == 2) {
    jsHelp('<b>Раздел:</b> Информация о пользовании чатом');
    jsHelp('<b>Чат</b> - выглядит как обычная веб-страница, где можно прочесть последние несколько десятков фраз, написанные участниками чата и модераторами.
                    Страница чата автоматически обновляется с заданной периодичностью. Участники чата которые нарушили правила общения могут получают молчанку и не могут общаться определенное время.
                    Для более подробной информации выберите следующий раздел.');
    jsHelp('Вырерите раздел справки: <i>(Отправить ответ в чат. Пример: &quot;/[1]&quot;)</i>');
    jsHelp('[0] Вернуться назад');
} elseif ($_SESSION['help_step'] == 3) {
    $load = sys_getloadavg();
    jsHelp('<b>Нагрузка:</b> ' . $load[0] . ' / ' . $load[1] . ' / ' . $load[2]);
    jsHelp('[1] Обновить');
    jsHelp('[0] Вернуться назад');
} elseif ($_SESSION['help_step'] == 4) {
    jsHelp('Спасибо за использование подсказки');
    $_SESSION['help_step'] = null;
}
jsHelp('----------------------------------------------------------------------------------------');
